## bamtools 2.5.2%2Bdfsg

=== debian/changelog ===
bamtools (2.5.2+dfsg-5) unstable; urgency=medium

  * d/control: add myself to uploaders.
  * d/rules: preserve pristine Doxyfile. (Closes: #1043881)
  * typo.patch: new: fix typo caught by lintian.

 -- Étienne Mollier <emollier@debian.org>  Fri, 15 Dec 2023 19:09:45 +0100

bamtools (2.5.2+dfsg-4) unstable; urgency=medium

  * Team upload.
  * d/control: libbamtools-doc depends on libjs-jquery.
    Thanks to Andreas Beckmann (Closes: #988848)
  * Standards-Version: 4.6.2 (routine-update)

 -- Étienne Mollier <emollier@debian.org>  Mon, 19 Dec 2022 22:45:16 +0100

bamtools (2.5.2+dfsg-3) unstable; urgency=medium

  * Reduce number of tests also for armel
    Closes: #992143

 -- Andreas Tille <tille@debian.org>  Fri, 02 Dec 2022 13:52:00 +0100

bamtools (2.5.2+dfsg-2) unstable; urgency=medium

  * Do not try to move Doxyfile.bak which does not exist any more in doxygen
    1.9.4
    Closes: #1015861
  * Build-Depends: pkg-config (since cmake is asking for it)
  * Standards-Version: 4.6.1 (routine-update)

 -- Andreas Tille <tille@debian.org>  Fri, 02 Sep 2022 19:53:29 +0200

bamtools (2.5.2+dfsg-1) experimental; urgency=medium

  [ Michael R. Crusoe ]
  * Standards-Version: 4.6.0 (routine-update)
  * refresh patches including reworking the shared & static library patch

  [ Andreas Tille ]
  * Remove Dominique Belhachemi from Uploaders (Thanks Dominique for all
    your work)
  * Remove unneeded lintian override

  [ Étienne Mollier ]
  * Remove gcc11.patch

 -- Andreas Tille <tille@debian.org>  Fri, 18 Mar 2022 13:25:54 +0100

bamtools (2.5.1+dfsg-10) unstable; urgency=medium

  * Team upload.
  * Add gcc11.patch (Closes: 983981)
  * Remove bamtools.lintian-overrides

 -- Étienne Mollier <emollier@debian.org>  Sat, 06 Nov 2021 19:31:45 +0100

=== debian/control ===
Source: bamtools
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Michael R. Crusoe <crusoe@debian.org>,
           Andreas Tille <tille@debian.org>,
           Kevin Murray <spam@kdmurray.id.au>,
           Étienne Mollier <emollier@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               d-shlibs,
               cmake,
               zlib1g-dev,
               libjsoncpp-dev,
               help2man,
               doxygen,
               pkg-config
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/med-team/bamtools
Vcs-Git: https://salsa.debian.org/med-team/bamtools.git
Homepage: https://github.com/pezmaster31/bamtools/wiki
Rules-Requires-Root: no

Package: bamtools
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: toolkit for manipulating BAM (genome alignment) files
 BamTools facilitates research analysis and data management using BAM
 files.  It copes with the enormous amount of data produced by current
 sequencing technologies that is typically stored in compressed, binary
 formats that are not easily handled by the text-based parsers commonly
 used in bioinformatics research.
 .
 BamTools provides both a C++ API for BAM file support as well as a
 command-line toolkit.
 .
 This is the bamtools command-line toolkit.
 .
 Available bamtools commands:
  convert  Converts between BAM and a number of other formats
  count    Prints number of alignments in BAM file(s)
  coverage Prints coverage statistics from the input BAM file
  filter   Filters BAM file(s) by user-specified criteria
  header   Prints BAM header information
  index    Generates index for BAM file
  merge    Merge multiple BAM files into single file
  random   Select random alignments from existing BAM file(s), intended more
           as a testing tool.
  resolve  Resolves paired-end reads (marking the IsProperPair flag as needed)
  revert   Removes duplicate marks and restores original base qualities
  sort     Sorts the BAM file according to some criteria
  split    Splits a BAM file on user-specified property, creating a new BAM
           output file for each value found
  stats    Prints some basic statistics from input BAM file(s)

Package: libbamtools-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libbamtools2.5.2 (= ${binary:Version}),
         ${misc:Depends},
         ${devlibs:Depends}
Suggests: libbamtools-doc (= ${binary:Version})
Breaks: libbamtools2.5.1
Replaces: libbamtools2.5.1
Description: C++ API for manipulating BAM (genome alignment) files
 BamTools facilitates research analysis and data management using BAM
 files.  It copes with the enormous amount of data produced by current
 sequencing technologies that is typically stored in compressed, binary
 formats that are not easily handled by the text-based parsers commonly
 used in bioinformatics research.
 .
 BamTools provides both a C++ API for BAM file support as well as a
 command-line toolkit.
 .
 This is the developers API package.

Package: libbamtools2.5.2
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: dynamic library for manipulating BAM (genome alignment) files
 BamTools facilitates research analysis and data management using BAM
 files.  It copes with the enormous amount of data produced by current
 sequencing technologies that is typically stored in compressed, binary
 formats that are not easily handled by the text-based parsers commonly
 used in bioinformatics research.
 .
 BamTools provides both a C++ API for BAM file support as well as a
 command-line toolkit.
 .
 This is the runtime library.

Package: libbamtools-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends},
         libjs-jquery
Description: docs for dynamic library for manipulating BAM (genome alignment) files
 BamTools facilitates research analysis and data management using BAM
 files.  It copes with the enormous amount of data produced by current
 sequencing technologies that is typically stored in compressed, binary
 formats that are not easily handled by the text-based parsers commonly
 used in bioinformatics research.
 .
 BamTools provides both a C++ API for BAM file support as well as a
 command-line toolkit.
 .
 This is the documentation for the library.

## bamtools 2.5.2+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

project(
    BamTools
    LANGUAGES CXX
    VERSION 2.5.2)

# Set Release type for builds where CMAKE_BUILD_TYPE is unset
# This is usually a good default as this implictly enables
#
#   CXXFLAGS = -O3 -DNDEBUG
#
if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Release)
endif()

# Adhere to GNU filesystem layout conventions
include(GNUInstallDirs)

# By default build bamtools as a static library
# Most users will prefer static libraries, distributions
# can always switch the standard CMake variable over to ON.
option(BUILD_SHARED_LIBS "Build all libraries as shared" OFF)

# If planning to run in Node.js environment, run:
# cmake -DEnableNodeJS=true
option(EnableNodeJS "Enable running in a Node.js environment" OFF)

# find system JsonCpp
find_package(PkgConfig)
pkg_search_module(JSONCPP jsoncpp>=1)

set(BAMTOOLS_PRIVATE_DEPS zlib)

if(JSONCPP_FOUND)
    message("Found system JsonCpp, not using bundled version")
    set(BAMTOOLS_PRIVATE_DEPS "${BAMTOOLS_PRIVATE_DEPS} jsoncpp")
else()
    message("Did NOT find system JsonCpp, instead using bundled version")
    set(JSONCPP_LDFLAGS jsoncpp)
    set(JSONCPP_INCLUDE_DIRS ${BamTools_SOURCE_DIR}/src/third_party/jsoncpp)
endif()

add_subdirectory(src)

# tests
include(CTest)
add_subdirectory(tests)

=== src/CMakeLists.txt ===
add_subdirectory(third_party)

if(MSVC)
    # We need full support for C++ exceptions
    add_compile_options(/EHsc)
    # -Wall -Wextra -pedantic
    add_compile_options(/W4)
    # 'argument' : conversion from 'type1' to 'type2', possible loss of data
    add_compile_options(/wd4244)
    # 'type' : class 'type1' needs to have dll-interface to be used by clients of class 'type2'
    # This is due to the fact that we're using STL containers in the interface
    add_compile_options(/wd4251)
    # 'var' : conversion from 'size_t' to 'type', possible loss of data
    add_compile_options(/wd4267)
    # cast truncates constant value
    add_compile_options(/wd4310)
    # declaration of 'identifier' hides previous local declaration
    add_compile_options(/wd4456)
    # 'strcat': This function or variable may be unsafe
    add_compile_options(/wd4996)
else()
    add_compile_options(-Wall -Wextra -pedantic)
    # define compiler flags for all code, copied from Autoconf's AC_SYS_LARGEFILE
    add_definitions(-D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE)
endif()

###########
# library #
###########

# needed for reading compressed BAM files
find_package(ZLIB REQUIRED)

# create main BamTools API library
add_library(
    BamTools

    api/BamAlignment.cpp
    api/BamMultiReader.cpp
    api/BamReader.cpp
    api/BamWriter.cpp
    api/SamHeader.cpp
    api/SamProgram.cpp
    api/SamProgramChain.cpp
    api/SamReadGroup.cpp
    api/SamReadGroupDictionary.cpp
    api/SamSequence.cpp
    api/SamSequenceDictionary.cpp
    api/internal/bam/BamHeader_p.cpp
    api/internal/bam/BamMultiReader_p.cpp
    api/internal/bam/BamRandomAccessController_p.cpp
    api/internal/bam/BamReader_p.cpp
    api/internal/bam/BamWriter_p.cpp
    api/internal/index/BamIndexFactory_p.cpp
    api/internal/index/BamStandardIndex_p.cpp
    api/internal/index/BamToolsIndex_p.cpp
    api/internal/io/BamDeviceFactory_p.cpp
    api/internal/io/BamFile_p.cpp
    api/internal/io/BamFtp_p.cpp
    api/internal/io/BamHttp_p.cpp
    api/internal/io/BamPipe_p.cpp
    api/internal/io/BgzfStream_p.cpp
    api/internal/io/ByteArray_p.cpp
    api/internal/io/HostAddress_p.cpp
    api/internal/io/HostInfo_p.cpp
    api/internal/io/HttpHeader_p.cpp
    api/internal/io/ILocalIODevice_p.cpp
    api/internal/io/RollingBuffer_p.cpp
    api/internal/io/TcpSocketEngine_p.cpp
    api/internal/io/TcpSocket_p.cpp
    api/internal/sam/SamFormatParser_p.cpp
    api/internal/sam/SamFormatPrinter_p.cpp
    api/internal/sam/SamHeaderValidator_p.cpp
    api/internal/utils/BamException_p.cpp
)

# The SONAME is bumped on every version increment
# as Bamtools does not yet guarantee a stable ABI
set_target_properties(
    BamTools PROPERTIES
    SOVERSION ${BamTools_VERSION}
    OUTPUT_NAME bamtools
    CXX_STANDARD 11
    CXX_STANDARD_REQUIRED ON
    CXX_EXTENSIONS OFF)
target_include_directories(
    BamTools PRIVATE
    ${ZLIB_INCLUDE_DIRS}
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_BINARY_DIR})
target_link_libraries(
    BamTools PRIVATE
    ${ZLIB_LIBRARIES})

if(WIN32)
    target_link_libraries(
        BamTools PRIVATE
        wsock32 ws2_32)
    target_sources(
        BamTools PRIVATE
        api/internal/io/TcpSocketEngine_win_p.cpp)
else()
    target_sources(
        BamTools PRIVATE
        api/internal/io/TcpSocketEngine_unix_p.cpp)
endif()

if(EnableNodeJS)
    target_compile_definitions(
        BamTools PRIVATE
        SYSTEM_NODEJS=1)
endif()

# convenience library
add_library(
    BamTools-utils
    STATIC
    utils/bamtools_fasta.cpp
    utils/bamtools_options.cpp
    utils/bamtools_pileup_engine.cpp
    utils/bamtools_utilities.cpp
)
set_target_properties(
    BamTools-utils PROPERTIES
    CXX_STANDARD 11
    CXX_STANDARD_REQUIRED ON
    CXX_EXTENSIONS OFF)
target_include_directories(
    BamTools-utils PRIVATE
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_BINARY_DIR})
target_link_libraries(
    BamTools-utils PRIVATE
    BamTools)

####################
# main application #
####################

configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/toolkit/bamtools_version.h.in
    ${CMAKE_CURRENT_BINARY_DIR}/bamtools_version.h
    @ONLY)

add_executable(
    bamtools_cmd

    toolkit/bamtools.cpp
    toolkit/bamtools_convert.cpp
    toolkit/bamtools_count.cpp
    toolkit/bamtools_coverage.cpp
    toolkit/bamtools_filter.cpp
    toolkit/bamtools_header.cpp
    toolkit/bamtools_index.cpp
    toolkit/bamtools_merge.cpp
    toolkit/bamtools_random.cpp
    toolkit/bamtools_resolve.cpp
    toolkit/bamtools_revert.cpp
    toolkit/bamtools_sort.cpp
    toolkit/bamtools_split.cpp
    toolkit/bamtools_stats.cpp
    ${CMAKE_CURRENT_BINARY_DIR}/bamtools_version.h
)
set_target_properties(
    bamtools_cmd PROPERTIES
    OUTPUT_NAME bamtools
    CXX_STANDARD 11
    CXX_STANDARD_REQUIRED ON
    CXX_EXTENSIONS OFF)
target_include_directories(
    bamtools_cmd PRIVATE
    ${JSONCPP_INCLUDE_DIRS}
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_BINARY_DIR})
target_link_libraries(
    bamtools_cmd PRIVATE
    BamTools BamTools-utils ${JSONCPP_LDFLAGS})

##############
# visibility #
##############

# can't inline this here, since we need to
# emulate the source tree and its includes.
add_subdirectory(api)

###################
# install targets #
###################

install(
    TARGETS BamTools
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

install(
    TARGETS bamtools_cmd
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

install(
    FILES
        api/BamAlgorithms.h
        api/BamAlignment.h
        api/BamAux.h
        api/BamConstants.h
        api/BamIndex.h
        api/BamMultiReader.h
        api/BamReader.h
        api/BamWriter.h
        api/IBamIODevice.h
        api/SamConstants.h
        api/SamHeader.h
        api/SamProgram.h
        api/SamProgramChain.h
        api/SamReadGroup.h
        api/SamReadGroupDictionary.h
        api/SamSequence.h
        api/SamSequenceDictionary.h
        api/api_global.h
        ${CMAKE_CURRENT_BINARY_DIR}/api/bamtools_api_export.h
    DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/bamtools/api
    COMPONENT Development)
install(
    FILES
        api/algorithms/Sort.h
    DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/bamtools/api/algorithms
    COMPONENT Development)
install(
    FILES
        shared/bamtools_global.h
    DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/bamtools/shared
    COMPONENT Development)

# pkg-config
configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/bamtools.pc.in
    ${CMAKE_CURRENT_BINARY_DIR}/bamtools-1.pc
    @ONLY)
install(
    FILES
        ${CMAKE_CURRENT_BINARY_DIR}/bamtools-1.pc
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
    COMPONENT Development)

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,6 @@
 Uploaders: Michael R. Crusoe <crusoe@debian.org>,
            Andreas Tille <tille@debian.org>,
            Kevin Murray <spam@kdmurray.id.au>,
-           Étienne Mollier <emollier@debian.org>
 Section: science
 Priority: optional
 Build-Depends: debhelper-compat (= 13),

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS=hardening=+bindnow

%:
	dh $@

override_dh_auto_test-indep:

override_dh_auto_test-arch:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	cd obj-* && ln -s src/toolkit/ bin
	dh_auto_test --arch
endif

override_dh_auto_build-indep:
	doxygen -u docs/Doxyfile
	doxygen docs/Doxyfile

override_dh_auto_install-indep:

override_dh_install-arch:
	dh_install --arch
	d-shlibmove --commit \
		    --multiarch \
		    --devunversioned \
		    --exclude-la \
		    --movedev debian/tmp/usr/include/* usr/include \
		    --movedev "debian/tmp/usr/lib/*/pkgconfig/*.pc" usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig \
		    debian/tmp/usr/lib/*/*.so

override_dh_install-indep:
	dh_install --indep
	rm -f debian/libbamtools-doc/usr/share/doc/libbamtools-dev/html/jquery.js
	ln -s /usr/share/javascript/jquery/jquery.js debian/libbamtools-doc/usr/share/doc/libbamtools-dev/html/jquery.js

describe-current-version:
	git describe --tags upstream | sed 's,^release-,,;s,-,+,;s,-,~,;'

## bamtools 2.5.3%2Bdfsg

=== debian/changelog ===
bamtools (2.5.3+dfsg-1) unstable; urgency=medium

  * Team upload
  * New upstream version
  * Fix FTBFS with CMake 4 (Closes: #1112718)
  * Standards-Version: 4.7.2 (routine-update)
  * Drop outdated patches
  * Add Doxyfile version patch

 -- Dominique Belhachemi <domibel@debian.org>  Fri, 26 Sep 2025 21:59:11 -0400

bamtools (2.5.2+dfsg-6) unstable; urgency=medium

  * Fix output data on bigendian architectures (Thanks a lot for the
    patch from Vladimir Petko <vladimir.petko@canonical.com>!)
    Closes: #1075990
  * Standards-Version: 4.7.0 (routine-update)
  * Build-Depends: s/pkg-config/pkgconf/

 -- Andreas Tille <tille@debian.org>  Fri, 12 Jul 2024 13:46:23 +0200

=== debian/control ===
--- 
+++ 
@@ -3,6 +3,7 @@
 Uploaders: Michael R. Crusoe <crusoe@debian.org>,
            Andreas Tille <tille@debian.org>,
            Kevin Murray <spam@kdmurray.id.au>,
+           Étienne Mollier <emollier@debian.org>
 Section: science
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
@@ -12,8 +13,8 @@
                libjsoncpp-dev,
                help2man,
                doxygen,
-               pkg-config
-Standards-Version: 4.6.2
+               pkgconf
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/med-team/bamtools
 Vcs-Git: https://salsa.debian.org/med-team/bamtools.git
 Homepage: https://github.com/pezmaster31/bamtools/wiki
@@ -56,7 +57,7 @@
 Architecture: any
 Multi-Arch: same
 Section: libdevel
-Depends: libbamtools2.5.2 (= ${binary:Version}),
+Depends: libbamtools2.5.3 (= ${binary:Version}),
          ${misc:Depends},
          ${devlibs:Depends}
 Suggests: libbamtools-doc (= ${binary:Version})
@@ -74,7 +75,7 @@
  .
  This is the developers API package.
 
-Package: libbamtools2.5.2
+Package: libbamtools2.5.3
 Architecture: any
 Multi-Arch: same
 Section: libs

## bamtools 2.5.3+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,9 +1,10 @@
-cmake_minimum_required(VERSION 3.0)
+cmake_minimum_required(VERSION 3.11)
+# need 3.11 for INCLUDE_GUARD_NAME in GENERATE_EXPORT_HEADER
 
 project(
     BamTools
     LANGUAGES CXX
-    VERSION 2.5.2)
+    VERSION 2.5.3)
 
 # Set Release type for builds where CMAKE_BUILD_TYPE is unset
 # This is usually a good default as this implictly enables

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -87,6 +87,9 @@
     BamTools PRIVATE
     ${ZLIB_INCLUDE_DIRS}
     ${CMAKE_CURRENT_SOURCE_DIR}
+    ${CMAKE_CURRENT_BINARY_DIR}
+    SYSTEM INTERFACE
+    ${CMAKE_CURRENT_SOURCE_DIR}
     ${CMAKE_CURRENT_BINARY_DIR})
 target_link_libraries(
     BamTools PRIVATE

=== tests/CMakeLists.txt ===
add_test(
    NAME bamtools_help
    COMMAND bamtools_cmd --help
)

add_test(
    NAME bamtools_stats
    COMMAND bamtools_cmd stats -in ${CMAKE_CURRENT_SOURCE_DIR}/data/sam_spec_example.bam
)

=== src/api/CMakeLists.txt ===
include(GenerateExportHeader)
generate_export_header(
    BamTools
    BASE_NAME API
    EXPORT_FILE_NAME bamtools_api_export.h
    INCLUDE_GUARD_NAME BAMTOOLS_API_EXPORT_H
)

=== debian/rules ===
--- 
+++ 
@@ -18,6 +18,7 @@
 endif
 
 override_dh_auto_build-indep:
+	cp docs/Doxyfile docs/Doxyfile.orig
 	doxygen -u docs/Doxyfile
 	doxygen docs/Doxyfile
 
@@ -40,3 +41,6 @@
 
 describe-current-version:
 	git describe --tags upstream | sed 's,^release-,,;s,-,+,;s,-,~,;'
+
+execute_after_dh_auto_clean:
+	test ! -f docs/Doxyfile.orig || mv docs/Doxyfile.orig docs/Doxyfile

=== debian/watch ===
version=4

opts="repacksuffix=+dfsg,dversionmangle=s/\+dfsg.*//,filenamemangle=s/(?:.*?)?v?(\d[\d.]*)\.tar\.gz/bamtools-$1.tar.gz/" \
https://github.com/pezmaster31/bamtools/tags .*/v?(\d[\d\.]+)\.tar\.gz
